## libvpl-tools 1.2.0

=== CMakeLists.txt ===
# ##############################################################################
# Copyright (C) Intel Corporation
#
# SPDX-License-Identifier: MIT
# ##############################################################################

cmake_minimum_required(VERSION 3.13.0)
if(MSVC)
  cmake_policy(SET CMP0091 NEW)
endif()

file(STRINGS "version.txt" version_txt)
project(vpl-tools VERSION ${version_txt})

set(CMAKE_MODULE_PATH "${CMAKE_MODULE_PATH};${CMAKE_CURRENT_SOURCE_DIR}/cmake")

#
# Project configuration options
#

# Set default build type to Release if not specified
if(NOT CMAKE_BUILD_TYPE)
  message(STATUS "Default CMAKE_BUILD_TYPE not set using Release")
  set(CMAKE_BUILD_TYPE
      "Release"
      CACHE
        STRING
        "Choose build type from: None Debug Release RelWithDebInfo MinSizeRel"
        FORCE)
endif()

# More code hardening on Windows
if(MSVC)
  if(${use_control_flow_guard})
    message("Setting CONTROL FLOW GUARD")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /guard:cf")
    set(CMAKE_EXE_LINKER_FLAGS "/guard:cf /DYNAMICBASE")
  endif()
  if(${use_qspectre})
    message("Setting QSPECTRE")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /Qspectre")
  endif()
endif()

# Project options
option(BUILD_SHARED_LIBS "Build shared instead of static libraries." OFF)
option(BUILD_TESTS "Build tests." OFF)

set(BUILD_EXPERIMENTAL
    ON
    CACHE BOOL "Build tools with EXPERIMENTAL APIs.")

# Test tool options for surface sharing
if(WIN32)
  set(TOOLS_DEFAULT_SCREEN_CAPTURE ON)
  set(TOOLS_DEFAULT_RENDER ON)
  set(TOOLS_DEFAULT_OPENCL ON)
  set(TOOLS_DEFAULT_X11 OFF)
else()
  set(TOOLS_DEFAULT_SCREEN_CAPTURE ON)
  set(TOOLS_DEFAULT_RENDER ON)
  set(TOOLS_DEFAULT_OPENCL OFF)
  set(TOOLS_DEFAULT_X11 ON)
endif()

option(TOOLS_ENABLE_SCREEN_CAPTURE
       "Enable screen capture in surface sharing test tools."
       ${TOOLS_DEFAULT_SCREEN_CAPTURE})

option(TOOLS_ENABLE_RENDER "Enable rendering in surface sharing test tools."
       ${TOOLS_DEFAULT_RENDER})

option(TOOLS_ENABLE_OPENCL "Enable OpenCL in surface sharing test tools."
       ${TOOLS_DEFAULT_OPENCL})

option(TOOLS_ENABLE_X11 "Enable X11 in surface sharing test tools."
       ${TOOLS_DEFAULT_X11})

option(USE_MSVC_STATIC_RUNTIME
       "Link MSVC runtime statically to all components." OFF)

if(USE_MSVC_STATIC_RUNTIME)
  set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>")
endif()

# Set output directories
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR})
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR})
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR})

include(cmake/InstallDirs.cmake)
include(cmake/PackageTarget.cmake)

# Set POSITION_INDEPENDENT_CODE property for all targets
set(CMAKE_POSITION_INDEPENDENT_CODE true)

# Keep executable bits on shared objects when installing regardless of distro
set(CMAKE_INSTALL_SO_NO_EXE 0)

include(cmake/CompileOptions.cmake)

if(BUILD_TESTS)
  include(CTest)
  enable_testing()
  # Build googletest
  set(BUILD_GMOCK
      OFF
      CACHE BOOL "" FORCE)
  set(INSTALL_GTEST
      OFF
      CACHE BOOL "" FORCE)
  set(gtest_disable_pthreads
      OFF
      CACHE BOOL "" FORCE)
  set(gtest_force_shared_crt
      ON
      CACHE BOOL "" FORCE)
  set(gtest_hide_internal_symbols
      OFF
      CACHE BOOL "" FORCE)

  add_subdirectory(ext/googletest)
  add_library(GTest::gtest ALIAS gtest)
  add_library(GTest::gtest_main ALIAS gtest_main)
endif()

add_subdirectory(tools)

install(
  FILES third-party-programs.txt
  DESTINATION ${VPL_INSTALL_LICENSEDIR}
  COMPONENT ${VPL_COMPONENT_LIB})

install(
  FILES LICENSE
  RENAME license.txt
  DESTINATION ${VPL_INSTALL_LICENSEDIR}
  COMPONENT ${VPL_COMPONENT_LIB})

set(CMAKE_INSTALL_SYSTEM_RUNTIME_COMPONENT ${VPL_COMPONENT_LIB})
include(InstallRequiredSystemLibraries)

message(
  STATUS "---------------- Configuration summary ------------------------------"
)
message(STATUS "CMake:")
message(STATUS "  CMAKE_VERSION                   : ${CMAKE_VERSION}")
message(STATUS "  CMAKE_GENERATOR                 : ${CMAKE_GENERATOR}")
message(STATUS "  CMAKE_BUILD_TOOL                : ${CMAKE_BUILD_TOOL}")
message(STATUS "Target:")
message(STATUS "  CMAKE_SYSTEM_NAME               : ${CMAKE_SYSTEM_NAME}")
message(STATUS "  CMAKE_SYSTEM_VERSION            : ${CMAKE_SYSTEM_VERSION}")
message(STATUS "  CMAKE_SYSTEM_PROCESSOR          : ${CMAKE_SYSTEM_PROCESSOR}")
message(STATUS "General:")
message(STATUS "  CMAKE_BUILD_TYPE                : ${CMAKE_BUILD_TYPE}")
message(STATUS "  CMAKE_TOOLCHAIN_FILE            : ${CMAKE_TOOLCHAIN_FILE}")
message(STATUS "  CMAKE_C_COMPILER                : ${CMAKE_C_COMPILER}")
message(STATUS "  CMAKE_CXX_COMPILER              : ${CMAKE_CXX_COMPILER}")
if(CMAKE_SIZEOF_VOID_P EQUAL 8)
  message(STATUS "  Build architecture              : 64-bit")
elseif(CMAKE_SIZEOF_VOID_P EQUAL 4)
  message(STATUS "  Build architecture              : 32-bit")
endif()
message(STATUS "Flags:")
message(STATUS "  CMAKE_C_FLAGS                   : ${CMAKE_C_FLAGS}")
message(STATUS "  CMAKE_CXX_FLAGS                 : ${CMAKE_CXX_FLAGS}")
message(STATUS "Release flags:")
message(STATUS "  CMAKE_C_FLAGS_RELEASE           : ${CMAKE_C_FLAGS_RELEASE}")
message(STATUS "  CMAKE_CXX_FLAGS_RELEASE         : ${CMAKE_CXX_FLAGS_RELEASE}")
message(STATUS "Debug flags:")
message(STATUS "  CMAKE_C_FLAGS_DEBUG             : ${CMAKE_C_FLAGS_DEBUG}")
message(STATUS "  CMAKE_CXX_FLAGS_DEBUG           : ${CMAKE_CXX_FLAGS_DEBUG}")
message(STATUS "RelWithDebRT flags:")
message(
  STATUS "  CMAKE_C_FLAGS_RELWITHDEBRT      : ${CMAKE_C_FLAGS_RELWITHDEBRT}")
message(
  STATUS "  CMAKE_CXX_FLAGS_RELWITHDEBRT    : ${CMAKE_CXX_FLAGS_RELWITHDEBRT}")
message(STATUS "Install:")
message(STATUS "  CMAKE_INSTALL_PREFIX            : ${CMAKE_INSTALL_PREFIX}")
message(
  STATUS "  CMAKE_INSTALL_FULL_BINDIR       : ${CMAKE_INSTALL_FULL_BINDIR}")
message(
  STATUS "  CMAKE_INSTALL_FULL_INCLUDEDIR   : ${CMAKE_INSTALL_FULL_INCLUDEDIR}")
message(
  STATUS "  CMAKE_INSTALL_FULL_LIBDIR       : ${CMAKE_INSTALL_FULL_LIBDIR}")
message(
  STATUS "  CMAKE_INSTALL_FULL_DOCDIR       : ${CMAKE_INSTALL_FULL_DOCDIR}")
message(
  STATUS "  VPL_INSTALL_FULL_PKGCONFIGDIR   : ${VPL_INSTALL_FULL_PKGCONFIGDIR}")
message(
  STATUS "  VPL_INSTALL_FULL_CMAKEDIR       : ${VPL_INSTALL_FULL_CMAKEDIR}")
message(STATUS "  VPL_INSTALL_FULL_ENVDIR         : ${VPL_INSTALL_FULL_ENVDIR}")
message(
  STATUS "  VPL_INSTALL_FULL_MODFILEDIR     : ${VPL_INSTALL_FULL_MODFILEDIR}")
message(
  STATUS "  VPL_INSTALL_FULL_EXAMPLEDIR     : ${VPL_INSTALL_FULL_EXAMPLEDIR}")
message(
  STATUS "  VPL_INSTALL_FULL_LICENSEDIR     : ${VPL_INSTALL_FULL_LICENSEDIR}")
message(
  STATUS "  VPL_INSTALL_FULL_PYTHONDIR      : ${VPL_INSTALL_FULL_PYTHONDIR}")
message(STATUS "Build:")
message(STATUS "  BUILD_SHARED_LIBS               : ${BUILD_SHARED_LIBS}")
message(STATUS "  BUILD_TESTS                     : ${BUILD_TESTS}")
message(STATUS "  BUILD_EXPERIMENTAL              : ${BUILD_EXPERIMENTAL}")
if(MSVC)
  message(
    STATUS "  USE_MSVC_STATIC_RUNTIME         : ${USE_MSVC_STATIC_RUNTIME}")
endif()
if(CMAKE_SYSTEM_NAME MATCHES Linux)
  message(STATUS "  ENABLE_VA                       : ${ENABLE_VA}")
  message(STATUS "  ENABLE_DRM                      : ${ENABLE_DRM}")
  message(STATUS "  ENABLE_WAYLAND                  : ${ENABLE_WAYLAND}")
  message(STATUS "  ENABLE_X11                      : ${ENABLE_X11}")
  message(STATUS "  ENABLE_DRI3                     : ${ENABLE_DRI3}")
endif()

message(STATUS "Surface sharing test tools:")
message(
  STATUS "  TOOLS_ENABLE_SCREEN_CAPTURE     : ${TOOLS_ENABLE_SCREEN_CAPTURE}")
message(STATUS "  TOOLS_ENABLE_RENDER             : ${TOOLS_ENABLE_RENDER}")
message(STATUS "  TOOLS_ENABLE_OPENCL             : ${TOOLS_ENABLE_OPENCL}")
message(STATUS "  TOOLS_ENABLE_X11                : ${TOOLS_ENABLE_X11}")

=== tools/legacy/sample_common/CMakeLists.txt ===
# ##############################################################################
# Copyright (C) 2005 Intel Corporation
#
# SPDX-License-Identifier: MIT
# ##############################################################################
set(TOOLS_DEFAULT ON)
if(CMAKE_SYSTEM_NAME MATCHES Linux)
  # Check dependencies up-front so we can set option defaults
  find_package(PkgConfig REQUIRED)
  # note: pkg-config version for libva is *API* version
  pkg_check_modules(PKG_LIBVA libva>=1.2 IMPORTED_TARGET GLOBAL)
  pkg_check_modules(PKG_LIBVA_DRM libva-drm>=1.2 IMPORTED_TARGET GLOBAL)
  pkg_check_modules(PKG_LIBDRM libdrm>=2.4.91 IMPORTED_TARGET GLOBAL)
  pkg_check_modules(PKG_X11 x11 IMPORTED_TARGET GLOBAL)
  pkg_check_modules(PKG_LIBVA_X11 libva-x11>=1.10.0 IMPORTED_TARGET GLOBAL)
  pkg_check_modules(
    PKG_XCB
    xcb
    xcb-dri3
    x11-xcb
    xcb-present
    IMPORTED_TARGET
    GLOBAL)
  pkg_check_modules(PKG_WAYLAND_CLIENT wayland-client IMPORTED_TARGET GLOBAL)
  find_program(WAYLAND_SCANNER_BIN "wayland-scanner")
  pkg_check_modules(PKG_WAYLAND_PROTOCOLS "wayland-protocols>=1.15")

  # Set defaults for ENABLE_VA
  if(PKG_LIBVA_FOUND AND PKG_LIBVA_DRM_FOUND)
    set(VA_DEFAULT ON)
  else()
    set(VA_DEFAULT OFF)
  endif()
  set(ENABLE_VA
      ${VA_DEFAULT}
      CACHE BOOL "Enable VA support in tools.")

  # Set default for ENABLE_DRM
  if(VA_DEFAULT AND PKG_LIBDRM_FOUND)
    set(DRM_DEFAULT ON)
  else()
    set(DRM_DEFAULT OFF)
  endif()
  set(ENABLE_DRM
      ${DRM_DEFAULT}
      CACHE BOOL "Enable VA/DRM in tools.")

  # Set default for ENABLE_WAYLAND
  if(VA_DEFAULT
     AND DRM_DEFAULT
     AND PKG_WAYLAND_CLIENT_FOUND
     AND WAYLAND_SCANNER_BIN
     AND PKG_WAYLAND_PROTOCOLS_FOUND)
    set(WAYLAND_DEFAULT ON)
  else()
    set(WAYLAND_DEFAULT OFF)
  endif()
  set(ENABLE_WAYLAND
      ${WAYLAND_DEFAULT}
      CACHE BOOL "Enable VA/Wayland in tools.")

  # Set default for ENABLE_X11
  if(VA_DEFAULT AND PKG_X11_FOUND)
    set(X11_DEFAULT ON)
  else()
    set(X11_DEFAULT OFF)
  endif()
  set(ENABLE_X11
      ${X11_DEFAULT}
      CACHE BOOL "Enable VA/X11 in tools.")
  # set default for ENABLE_DRI3
  if(X11_DEFAULT
     AND PKG_XCB_FOUND
     AND PKG_LIBDRM_FOUND)
    set(DRI3_DEFAULT ON)
  else()
    set(DRI3_DEFAULT OFF)
  endif()
  set(ENABLE_DRI3
      ${DRI3_DEFAULT}
      CACHE BOOL "Enable X11/DRI3 in tools.")
endif()

# Error if options conflict
if(NOT ENABLE_VA
   AND (ENABLE_DRM
        OR ENABLE_WAYLAND
        OR ENABLE_X11
        OR ENABLE_DRI3
       ))
  message(
    SEND_ERROR "conflicting options: VA backend requested but ENABLE_VA=OFF")
endif()

if(ENABLE_WAYLAND AND NOT ENABLE_DRM)
  message(SEND_ERROR "conflicting options: Wayland requires ENABLE_DRM=ON")
endif()

if(ENABLE_DRI3 AND (NOT ENABLE_X11 OR NOT ENABLE_DRM))
  message(
    SEND_ERROR
      "conflicting options: DRI3 requires ENABLE_X11=ON and ENABLE_DRM=ON")
endif()

set(TARGET sample_common)
add_library(${TARGET} STATIC)

target_sources(
  ${TARGET}
  PRIVATE src/avc_bitstream.cpp
          src/avc_nal_spl.cpp
          src/avc_spl.cpp
          src/base_allocator.cpp
          src/brc_routines.cpp
          src/d3d11_allocator.cpp
          src/d3d11_device.cpp
          src/d3d_allocator.cpp
          src/d3d_device.cpp
          src/decode_render.cpp
          src/general_allocator.cpp
          src/mfx_buffering.cpp
          src/parameters_dumper.cpp
          src/plugin_utils.cpp
          src/preset_manager.cpp
          src/sample_utils.cpp
          src/sysmem_allocator.cpp
          src/v4l2_util.cpp
          src/vaapi_allocator.cpp
          src/vaapi_device.cpp
          src/vaapi_utils_android.cpp
          src/vaapi_utils.cpp
          src/vaapi_utils_drm.cpp
          src/vaapi_utils_x11.cpp
          src/vpl_implementation_loader.cpp
          src/vpp_ex.cpp
          src/vm/atomic.cpp
          src/vm/atomic_linux.cpp
          src/vm/shared_object.cpp
          src/vm/shared_object_linux.cpp
          src/vm/thread_linux.cpp
          src/vm/thread_windows.cpp
          src/vm/time.cpp
          src/vm/time_linux.cpp)

target_include_directories(
  ${TARGET} PUBLIC ${CMAKE_CURRENT_SOURCE_DIR}/include
                   ${CMAKE_CURRENT_SOURCE_DIR}/include/vm)

target_compile_definitions(${TARGET}
                           PUBLIC TOOLS_VERSION_MAJOR=${PROJECT_VERSION_MAJOR})
target_compile_definitions(${TARGET}
                           PUBLIC TOOLS_VERSION_MINOR=${PROJECT_VERSION_MINOR})
target_compile_definitions(${TARGET}
                           PUBLIC TOOLS_VERSION_PATCH=${PROJECT_VERSION_PATCH})

if(MSVC)
  target_compile_definitions(${TARGET} PUBLIC _CRT_SECURE_NO_WARNINGS)
endif()

target_compile_definitions(${TARGET} PUBLIC MFX_DEPRECATED_OFF)

find_package(VPL REQUIRED)
target_link_libraries(${TARGET} PUBLIC VPL::dispatcher
                                       media_sdk_compatibility_headers)

if(BUILD_EXPERIMENTAL)
  target_compile_definitions(${TARGET} PUBLIC -DONEVPL_EXPERIMENTAL)
endif()

if(CMAKE_SYSTEM_NAME MATCHES Linux)
  target_compile_definitions(${TARGET} PUBLIC LINUX64)

  if(NOT ENABLE_VA)
    message(STATUS "Building ${TARGET} without VA support")
  else()
    if(PKG_LIBVA_FOUND AND PKG_LIBVA_DRM_FOUND)
      target_compile_definitions(${TARGET} PUBLIC LIBVA_SUPPORT)
      target_include_directories(${TARGET} PUBLIC ${PKG_LIBVA_INCLUDE_DIRS})

      if(ENABLE_DRM)
        if(PKG_LIBDRM_FOUND)
          target_compile_definitions(${TARGET} PUBLIC LIBVA_DRM_SUPPORT)
          target_include_directories(${TARGET}
                                     PUBLIC ${PKG_LIBDRM_INCLUDE_DIRS})

          if("${PKG_LIBDRM_VERSION}" VERSION_GREATER 2.4.113)
            target_compile_definitions(${TARGET}
                                       PUBLIC DRM_LINUX_MODIFIER_TILED4_SUPPORT)
          else()
            message(
              STATUS
                "libdrm version ${PKG_LIBDRM_VERSION} does not support I915_FORMAT_MOD_4_TILED"
            )
          endif()

          if("${PKG_LIBDRM_VERSION}" VERSION_GREATER 2.4.107)
            target_compile_definitions(
              ${TARGET} PUBLIC DRM_LINUX_FORMAT_MODIFIER_BLOB_SUPPORT)
          else()
            message(
              STATUS
                "libdrm version ${PKG_LIBDRM_VERSION} does not support drmModeFormatModifierBlobIterNext() API"
            )
          endif()

          if("${PKG_LIBDRM_VERSION}" VERSION_GREATER 2.4.104)
            target_compile_definitions(${TARGET} PUBLIC DRM_LINUX_HDR_SUPPORT)
          else()
            message(
              STATUS
                "libdrm version ${PKG_LIBDRM_VERSION} does not support hdr_output_metadata header"
            )
          endif()

          if("${PKG_LIBDRM_VERSION}" VERSION_GREATER 2.4.97)
            target_compile_definitions(${TARGET} PUBLIC DRM_LINUX_P010_SUPPORT)
          else()
            message(
              STATUS
                "libdrm version ${PKG_LIBDRM_VERSION} does not support DRM_FORMAT_P010"
            )
          endif()

        else()
          message(
            SEND_ERROR
              "libdrm not found: set ENABLE_DRM=OFF to to build tools with DRM disabled"
          )
        endif()
      else()
        message(STATUS "Building ${TARGET} without DRM support")
      endif()

      if(ENABLE_WAYLAND)
        if(PKG_WAYLAND_CLIENT_FOUND)
          target_compile_definitions(${TARGET} PUBLIC LIBVA_WAYLAND_SUPPORT)
          target_include_directories(${TARGET}
                                     PUBLIC ${PKG_WAYLAND_CLIENT_INCLUDE_DIRS})
          target_include_directories(
            ${TARGET}
            PUBLIC ${CMAKE_CURRENT_SOURCE_DIR}/../sample_misc/wayland/include)
          if(WAYLAND_SCANNER_BIN AND PKG_WAYLAND_PROTOCOLS_FOUND)
            pkg_get_variable(WAYLAND_PROTOCOLS_PATH wayland-protocols
                             pkgdatadir)
            if(WAYLAND_PROTOCOLS_PATH)
              find_file(
                WAYLAND_LINUX_DMABUF_XML_PATH linux-dmabuf-unstable-v1.xml
                PATHS ${WAYLAND_PROTOCOLS_PATH}/unstable/linux-dmabuf
                NO_DEFAULT_PATH)
              find_file(WAYLAND_LINUX_XDG_SHELL_XML_PATH xdg-shell.xml
                        PATHS ${WAYLAND_PROTOCOLS_PATH}/stable/xdg-shell
                              NO_DEFAULT_PATH)
            endif()
          else()
            message(
              SEND_ERROR
                "wayland-protocols not found: set ENABLE_WAYLAND=OFF to build tools with Wayland disabled"
            )
          endif()

          if(WAYLAND_LINUX_DMABUF_XML_PATH)
            target_compile_definitions(${TARGET}
                                       PUBLIC WAYLAND_LINUX_DMABUF_SUPPORT)
            target_include_directories(
              ${TARGET}
              PUBLIC ${CMAKE_BINARY_DIR}/tools/legacy/sample_misc/wayland)
          endif()

          if(WAYLAND_LINUX_XDG_SHELL_XML_PATH)
            target_compile_definitions(${TARGET}
                                       PUBLIC WAYLAND_LINUX_XDG_SHELL_SUPPORT)
            target_include_directories(
              ${TARGET}
              PUBLIC ${CMAKE_BINARY_DIR}/tools/legacy/sample_misc/wayland)
          else()
            message(SEND_ERROR "xdg-shell.xml could not be found")
          endif()

        else()
          message(
            SEND_ERROR
              "wayland-client not found: set ENABLE_WAYLAND=OFF to build tools with Wayland disabled"
          )
        endif()
      else()
        message(STATUS "Building ${TARGET} without Wayland support")
      endif()

      if(ENABLE_X11)
        if(PKG_X11_FOUND)
          target_compile_definitions(${TARGET} PUBLIC LIBVA_X11_SUPPORT)
          target_link_libraries(${TARGET} PUBLIC PkgConfig::PKG_X11)

          if(ENABLE_DRI3)
            if(PKG_XCB_FOUND AND PKG_LIBDRM_FOUND)
              target_compile_definitions(${TARGET} PUBLIC X11_DRI3_SUPPORT)
              target_link_libraries(${TARGET} PUBLIC PkgConfig::PKG_XCB)
            else()
              message(
                SEND_ERROR
                  "DRI3 dependencies not found: set ENABLE_DRI3=OFF to to build tools with DRI3 disabled"
              )
            endif()
          else()
            message(STATUS "Building ${TARGET} without DRI3 support")
          endif()
        else()
          message(
            SEND_ERROR
              "X11 modules not found: set ENABLE_X11=OFF to build tools with X11 disabled"
          )
        endif()
      else()
        message(STATUS "Building ${TARGET} without X11 support")
      endif()
    else()
      message(
        SEND_ERROR
          "libva not found: set ENABLE_VA=OFF to build tools with VA disabled")
    endif()
  endif()

  target_link_libraries(${TARGET} PUBLIC ${CMAKE_DL_LIBS})

  set(CMAKE_THREAD_PREFER_PTHREAD TRUE)
  set(THREADS_PREFER_PTHREAD_FLAG TRUE)
  find_package(Threads REQUIRED)
  target_link_libraries(${TARGET} PUBLIC Threads::Threads)
else()
  target_compile_definitions(${TARGET} PUBLIC MFX_D3D11_SUPPORT NOMINMAX)
  target_link_libraries(${TARGET} PUBLIC DXGI D3D11 D3D9 DXVA2)
endif()

=== debian/changelog ===
libvpl-tools (1.2.0-1) unstable; urgency=medium

  * Initial version. (Closes: #1082794)

 -- Timo Aaltonen <tjaalton@debian.org>  Thu, 26 Sep 2024 17:47:41 +0300

## libvpl-tools 1.3.0

=== tools/cli/CMakeLists.txt ===
# ##############################################################################
# Copyright (C) Intel Corporation
#
# SPDX-License-Identifier: MIT
# ##############################################################################

add_subdirectory(system_analyzer)
add_subdirectory(val-surface-sharing)
add_subdirectory(vpl-import-export)
add_subdirectory(vpl-inspect)

=== .github/workflows/lint/requirements.txt ===
virtualenv==v20.24.5
pre-commit

=== .github/workflows/summary/requirements.txt ===
defusedxml
xlsxwriter

=== tools/legacy/sample_vpp/CMakeLists.txt ===
# ##############################################################################
# Copyright (C) 2005 Intel Corporation
#
# SPDX-License-Identifier: MIT
# ##############################################################################

set(TARGET sample_vpp)
set(SOURCES "")
list(
  APPEND
  SOURCES
  src/main.cpp
  src/sample_vpp.cpp
  src/sample_vpp_config.cpp
  src/sample_vpp_frc.cpp
  src/sample_vpp_frc_adv.cpp
  src/sample_vpp_parser.cpp
  src/sample_vpp_pts.cpp
  src/sample_vpp_roi.cpp
  src/sample_vpp_utils.cpp)

find_package(VPL REQUIRED)

add_executable(${TARGET} ${SOURCES})
target_include_directories(${TARGET}
                           PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/include)

target_link_libraries(${TARGET} PRIVATE sample_common)

if(MSVC)
  target_compile_definitions(${TARGET} PRIVATE _CRT_SECURE_NO_WARNINGS)
endif()

install(TARGETS ${TARGET} RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
                                  COMPONENT ${VPL_COMPONENT_TOOLS})

if(BUILD_TESTS)
  set(BUILD_SHARED_LIBS OFF)

  set(BUILD_GMOCK
      OFF
      CACHE BOOL "" FORCE)
  set(INSTALL_GTEST
      OFF
      CACHE BOOL "" FORCE)
  set(gtest_disable_pthreads
      OFF
      CACHE BOOL "" FORCE)
  set(gtest_force_shared_crt
      ON
      CACHE BOOL "" FORCE)
  set(gtest_hide_internal_symbols
      OFF
      CACHE BOOL "" FORCE)

  add_executable(sample_vpp_test)

  target_sources(
    sample_vpp_test
    PRIVATE test/test_main.cpp
            src/sample_vpp.cpp
            src/sample_vpp_config.cpp
            src/sample_vpp_frc.cpp
            src/sample_vpp_frc_adv.cpp
            src/sample_vpp_parser.cpp
            src/sample_vpp_pts.cpp
            src/sample_vpp_roi.cpp
            src/sample_vpp_utils.cpp)

  target_link_libraries(sample_vpp_test PUBLIC GTest::gtest)
  target_link_libraries(sample_vpp_test PRIVATE sample_common)
  target_include_directories(
    sample_vpp_test PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/include
                            ${CMAKE_SOURCE_DIR}/api/vpl)

  if(BUILD_EXPERIMENTAL)
    target_compile_definitions(sample_vpp_test PRIVATE -DONEVPL_EXPERIMENTAL)
  endif()

  target_compile_definitions(sample_vpp_test PRIVATE MFX_ONEVPL)

  include(GoogleTest)
  gtest_discover_tests(sample_vpp_test)

endif()

=== tools/legacy/sample_misc/wayland/CMakeLists.txt ===
# ##############################################################################
# Copyright (C) 2005 Intel Corporation
#
# SPDX-License-Identifier: MIT
# ##############################################################################

set(TARGET vpl_wayland)
if(UNIX)
  if(NOT ENABLE_WAYLAND)
    return()
  endif()
else()
  return()
endif()

if(NOT PKG_WAYLAND_CLIENT_FOUND)
  message(
    SEND_ERROR
      "wayland-client not found: set ENABLE_WAYLAND=OFF to build tools with wayland disabled"
  )
endif()

find_package(PkgConfig REQUIRED)
pkg_check_modules(PKGConfig_LIBDRM libdrm>=2.4.91 IMPORTED_TARGET)

if(PKGConfig_LIBDRM_FOUND)
  add_library(${TARGET} SHARED)
  set_target_properties(${TARGET} PROPERTIES VERSION 1.0.0)

  target_include_directories(
    ${TARGET} PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/include
                      ${CMAKE_SOURCE_DIR}/api/vpl)

  target_sources(
    ${TARGET}
    PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/src/class_wayland.cpp
            ${CMAKE_CURRENT_SOURCE_DIR}/src/listener_wayland.cpp
            ${CMAKE_CURRENT_SOURCE_DIR}/src/wayland-drm-protocol.c)

  if(WAYLAND_SCANNER_BIN
     AND PKG_WAYLAND_PROTOCOLS_FOUND
     AND WAYLAND_LINUX_XDG_SHELL_XML_PATH)
    execute_process(
      COMMAND
        "${WAYLAND_SCANNER_BIN_PATH}\/${WAYLAND_SCANNER_BIN}" "client-header"
        "${WAYLAND_LINUX_XDG_SHELL_XML_PATH}"
        "tools/legacy/sample_misc/wayland/xdg-shell-client-protocol.h"
      WORKING_DIRECTORY "${CMAKE_BINARY_DIR}"
      RESULT_VARIABLE WAYLAND_SCANNER_RESULT)
    if(WAYLAND_SCANNER_RESULT)
      message(FATAL_ERROR "Failed to generate xdg-shell-client-protocol.h")
    endif()

    execute_process(
      COMMAND
        "${WAYLAND_SCANNER_BIN_PATH}\/${WAYLAND_SCANNER_BIN}" "private-code"
        "${WAYLAND_LINUX_XDG_SHELL_XML_PATH}"
        "tools/legacy/sample_misc/wayland/xdg-shell-protocol.c"
      WORKING_DIRECTORY "${CMAKE_BINARY_DIR}"
      RESULT_VARIABLE WAYLAND_SCANNER_RESULT)
    if(WAYLAND_SCANNER_RESULT)
      message(FATAL_ERROR "Failed to generate xdg-shell-protocol.c")
    endif()

    target_include_directories(
      ${TARGET} PRIVATE ${CMAKE_BINARY_DIR}/tools/legacy/sample_misc/wayland)
    target_sources(
      ${TARGET}
      PRIVATE
        ${CMAKE_BINARY_DIR}/tools/legacy/sample_misc/wayland/xdg-shell-protocol.c
    )
  endif()

  if(WAYLAND_SCANNER_BIN
     AND PKG_WAYLAND_PROTOCOLS_FOUND
     AND WAYLAND_LINUX_DMABUF_XML_PATH)
    execute_process(
      COMMAND
        "${WAYLAND_SCANNER_BIN_PATH}\/${WAYLAND_SCANNER_BIN}" "client-header"
        "${WAYLAND_LINUX_DMABUF_XML_PATH}"
        "tools/legacy/sample_misc/wayland/linux-dmabuf-unstable-v1.h"
      WORKING_DIRECTORY "${CMAKE_BINARY_DIR}"
      RESULT_VARIABLE WAYLAND_SCANNER_RESULT)
    if(WAYLAND_SCANNER_RESULT)
      message(FATAL_ERROR "Failed to generate linux-dmabuf-unstable-v1.h")
    endif()

    execute_process(
      COMMAND
        "${WAYLAND_SCANNER_BIN_PATH}\/${WAYLAND_SCANNER_BIN}" "private-code"
        "${WAYLAND_LINUX_DMABUF_XML_PATH}"
        "tools/legacy/sample_misc/wayland/linux-dmabuf-unstable-v1.c"
      WORKING_DIRECTORY "${CMAKE_BINARY_DIR}"
      RESULT_VARIABLE WAYLAND_SCANNER_RESULT)
    if(WAYLAND_SCANNER_RESULT)
      message(FATAL_ERROR "Failed to generate linux-dmabuf-unstable-v1.c")
    endif()

    target_include_directories(
      ${TARGET} PRIVATE ${CMAKE_BINARY_DIR}/tools/legacy/sample_misc/wayland)
    target_sources(
      ${TARGET}
      PRIVATE
        ${CMAKE_BINARY_DIR}/tools/legacy/sample_misc/wayland/linux-dmabuf-unstable-v1.c
    )
  else()
    message(
      SEND_ERROR
        "Wayland modules not found: set ENABLE_WAYLAND=OFF to build tools with wayland disabled"
    )
  endif()

  target_link_libraries(${TARGET} PRIVATE sample_common wayland-client va drm
                                          drm_intel)

  install(TARGETS ${TARGET}
          LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}/${PROJECT_NAME}"
                  COMPONENT ${VPL_COMPONENT_TOOLS})
else()
  message(
    SEND_ERROR "libdrm not found: set BUILD_TOOLS=OFF to skip building tools")
endif()

=== debian/changelog ===
libvpl-tools (1.3.0-1) unstable; urgency=medium

  * New upstream release.

 -- Timo Aaltonen <tjaalton@debian.org>  Thu, 06 Feb 2025 09:40:50 +0200

=== debian/control ===
Source: libvpl-tools
Section: graphics
Priority: optional
Maintainer: Timo Aaltonen <tjaalton@debian.org>
Build-Depends: debhelper-compat (= 13),
 cmake,
 pkgconf,
 libdrm-dev,
 libva-dev,
 libvpl-dev,
 libx11-dev,
 libx11-xcb-dev,
 libxcb-present-dev,
 libxcb-dri3-dev,
 libwayland-dev,
 wayland-protocols,
Standards-Version: 4.7.0
Homepage: https://github.com/intel/libvpl-tools
Vcs-Browser: https://salsa.debian.org/debian/libvpl-tools
Vcs-Git: https://salsa.debian.org/debian/libvpl-tools.git
Rules-Requires-Root: no

Package: libvpl-tools
Architecture: amd64
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: onevpl-tools
Provides: onevpl-tools
Replaces: onevpl-tools
Description: Intel Video Processing Library -- command line tools
 Intel Video Processing Library (Intel VPL) provides access to hardware
 accelerated video decode, encode, and processing capabilities on Intel
 GPUs to support AI visual inference, media delivery, cloud gaming, and virtual
 desktop infrastructure use cases.
 .
 This package includes the command line tools.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --builddir build/

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_BUILD_TYPE=release \
		-DVPL_INSTALL_ENVDIR=/usr/share/vpl/env \
		-DVPL_INSTALL_MODFILEDIR=/usr/share/vpl/modulefiles

override_dh_auto_install:
	dh_auto_install --destdir=debian/tmp
	# clean redundant license files
	rm -rf debian/tmp/usr/share/vpl-tools/licensing

override_dh_clean:
	rm -rf _build
	dh_clean

## libvpl-tools 1.4.0~1ppa1

=== debian/changelog ===
libvpl-tools (2:1.4.0~1ppa1-noble1) noble; urgency=medium

  * Bump to 1.4.0

  * d/p: drop patches no longer applicable
    - 0002-Force-rDRM-setmode-highest-resolution-for-above-5k.patch

 -- Mustaffa, Mustamin B <mustamin.b.mustaffa@intel.com>  Fri, 22 Aug 2025 17:18:24 +0800

libvpl-tools (2:1.3.0~1ppa1-noble2) noble; urgency=medium

  * debian/patches: Remove Y210 YUV writer shift
    - 0003-Remove-Y210-YUV-writer-shift.patch

 -- Cheah, Vincent Beng Keat <vincent.beng.keat.cheah@intel.com>  Thu, 26 Jun 2025 08:10:35 +0800

libvpl-tools (2:1.3.0~1ppa1-noble1) noble; urgency=medium

  * Bump to 1.3.0 version
  * d/p: drop patches already merged.
    - 0001-Enable-AV1-encode-Screen-Content-Coding-tools.patch
    - 0002-Implement-GTK-using-OpenGL-in-SD-and-SMT.patch
  * d/p: rebased patches
    - 0001-Remove-redundant-fd-close.patch
    - 0002-Force-rDRM-setmode-highest-resolution-for-above-5k.patch

 -- Lim, Siew Hoon <siew.hoon.lim@intel.com>  Thu, 27 Mar 2025 18:45:14 +0800

libvpl-tools (2:1.2.0~1ppa1-noble3) noble; urgency=medium

  * debian/patches: Fix 8K rDRM render
    - 0004-Force-rDRM-setmode-highest-resolution-for-above-5k.patch

 -- Cheah, Vincent Beng Keat <vincent.beng.keat.cheah@intel.com>  Fri, 19 Jul 2024 14:37:57 +0800

libvpl-tools (2:1.2.0~1ppa1-noble2) noble; urgency=medium

  * debian/patches: Fix 8K X11 rendering
    - 0003-Remove-redundant-fd-close.patch

 -- Hoe, Sheng Yang <sheng.yang.hoe@intel.com>  Wed, 06 Nov 2024 13:48:05 +0800

libvpl-tools (2:1.2.0~1ppa1-noble1) noble; urgency=medium

  * Bump to 1.2.0 version

  * d/patches: drop list of patches already merged.
    - 0001-Correct-va-attrib-for-vaapiallocator.patch
    - 0002-Enable-YUV400-JPEG-Enc-for-vaapi.patch
    - 0003-Enable-YUV400-JPEG-Enc-for-linux-vaapi-only.patch
    - 0004-Fix-rDRM-DMA-methods.patch
    - 0005-Force-allocator-to-use-DRM_PRIME-for-rDRM.patch
    - 0006-Enable-VVC-in-sample_decode.patch
    - 0007-Fix-X11-rendering-for-xe.patch
    - 0008-Fix-code-formatting.patch

  * d/patches: rebased the patches
    - 0001-Enable-AV1-encode-Screen-Content-Coding-tools.patch
    - 0002-Implement-GTK-using-OpenGL-in-SD-and-SMT.patch

 -- Lim, Siew Hoon <siew.hoon.lim@intel.com>  Wed, 30 Oct 2024 14:07:46 +0800

libvpl-tools (2:1.0.0~1ppa1-noble5) noble; urgency=medium

  * debian/patches: Implement GTK using OpenGL in SD and SMT
    - 0001-Implement-GTK-using-OpenGL-in-SD-and-SMT.patch 

 -- Lui, Jonathan Ming Jun <jonathan.ming.jun.lui@intel.com>  Thu, 17 Oct 2024 04:05:57 +0000

libvpl-tools (2:1.0.0~1ppa1-noble4) noble; urgency=medium

  * debian/patches: Enable AV1 encode Screen Content Coding tools
    - 0009-Enable-AV1-encode-Screen-Content-Coding-tools.patch

 -- Hoe, Sheng Yang <sheng.yang.hoe@intel.com>  Wed, 18 Sep 2024 11:02:54 +0800

libvpl-tools (2:1.0.0~1ppa1-noble3) noble; urgency=medium

  * Add d/libvpl-tools.install file.

 -- Lim, Siew Hoon <siew.hoon.lim@intel.com>  Tue, 10 Sep 2024 08:28:30 +0800

libvpl-tools (2:1.0.0~1ppa1-noble2) noble; urgency=medium

  *  d/patches: a list of code fixed on sample app not yet merged.
     - 0001-Correct-va-attrib-for-vaapiallocator.patch
     - 0002-Enable-YUV400-JPEG-Enc-for-vaapi.patch
     - 0003-Enable-YUV400-JPEG-Enc-for-linux-vaapi-only.patch
     - 0004-Fix-rDRM-DMA-methods.patch
     - 0005-Force-allocator-to-use-DRM_PRIME-for-rDRM.patch
     - 0006-Enable-VVC-in-sample_decode.patch
     - 0007-Fix-X11-rendering-for-xe.patch
     - 0008-Fix-code-formatting.patch

 -- Lim, Siew Hoon <siew.hoon.lim@intel.com>  Tue, 10 Sep 2024 08:11:03 +0800

libvpl-tools (2:1.0.0~1ppa1-noble1) noble; urgency=medium

  * Initial Release.

 -- LEE CHEE YANG <chee.yang.lee@intel.com>  Thu, 11 Jul 2024 12:58:47 +0800

=== debian/control ===
Source: libvpl-tools
Section: libs
Priority: optional
Maintainer: Lee Chee Yang <chee.yang.lee@intel.com>
Build-Depends: debhelper-compat (= 13),
 cmake,
 libdrm-dev,
 libva-dev,
 libwayland-dev,
 libx11-dev,
 libx11-xcb-dev,
 libxcb1-dev,
 libxcb-dri3-dev,
 libxcb-present-dev,
 pkg-config,
 wayland-protocols,
 libgtkmm-4.0-dev,
 libvpl-dev (>= 2.11.0)
Standards-Version: 4.6.0
Homepage: 

Package: libvpl-tools
Architecture: amd64
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: oneAPI Video Processing Library -- command line tools
 The oneAPI Video Processing Library (oneVPL) provides a single video processing
 API for encode, decode, and video processing that works across a wide range of
 accelerators.
 .
 This repository contains the following components of oneVPL:
 .
  - Copies of the oneVPL Specification API header files
  - oneVPL dispatcher
  - Examples demonstrating API usage
  - oneVPL command line tools
 .
 This project is part of the larger oneAPI project.
 .
 This package includes the command line tools.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_BUILD_TYPE=Release
